/*
 * Sample Rexx/ISAM for C/Database Toolchest test program
 * Dumps the contents of the specified table (like Mix dumpdata)
 * Optionally pass '-s' as first parameter and filed names are also
 * displayed.
 */
Trace o
Call RxFuncAdd 'CDTLoadFuncs', 'rxcdt', 'CDTLoadFuncs'
Call cdtloadfuncs
Parse Arg fn
If fn = '' Then Call Usage
If Word( fn, 1 ) = '-s' Then
   Do
      show = 1
      fn = Subword( fn, 2 )
   End
Else show = 0

db = cdtopen_db( fn, 'shared', 'readonly' )
If db = 'ERROR' Then Call Abort 'Opening'
num_fields = cdtgetfldcount( db )
If num_fields = 'ERROR' Then Call Abort 'Getting number of fields'
If show Then
   Do
      Call cdtgetfldnames db, 'desc.'
      Say 'Fields for table' fn 'are...'
      Do i = 1 To desc.0
         Say desc.i
      End
   End
idx = cdtopen_index( db )
if idx = 'ERROR' Then Call Abort 'Getting physical index'
rc = cdtfindhead( db, idx )
if rc = 'ERROR' Then Call Abort 'Getting head'
If rc \= 'EOI' & rc \= 'BOI' Then
   Do
      line = ''
      Do forever
         If cdtgetrec( db, idx, 'DATA.' ) = 'ERROR' Then Call Abort 'Getting record'
         line = ''
         Do i = 1 To data.0
            If Left( cdtgetfldtype( db, i ), 1 ) = 'B' Then
               Do
                  col = c2x( data.i )
               End
            Else
               Do
                  col = data.i
               End
            line = line'|'col
         End
         Say line
         rc = cdtfindnext( db, idx )
         if rc \= 'OK' Then Leave
      End
   End
Call cdtclose_db db

Call cdtisamexit
Call cdtdropfuncs
Return

Abort: Procedure
Parse Arg msg
Say msg
Call cdtgeterror 'error.'
Say 'internal:' error.internal
Say 'cdtmsg:  ' error.cdtmsg
Say 'cberrmsg:' error.cberrmsg
Say 'cbfcnmsg:' error.cbfcnmsg
Say 'cbconmsg:' error.cbconmsg
Call cdtisamexit
Call cdtdropfuncs
Exit 1

Usage: Procedure
Say 'Dumps data from specified MIX database table to the screen'
Say 'Usage: dumpdata.rex [-s] dbname'
Say '       dbname    : name of database'
Say '       -s        : show field names'
Say 'eg:  dumpdata.rex emp'
Say '     dumpdata.rex -s emp'
Exit 1
